#!/usr/bin/perl

$PRI_SIZE = 0;		# Size of articles in primary newsgroup.
$PRI_COUNT = 1;		# Count...
$SEC_SIZE = 2;		# Size of articles in cross-posted newsgroup.
$SEC_COUNT = 3;		# Count...

$colldate = 0;


sub dumpdata {
    if (defined $dumpflag) {
	my $logname = "temp.artsday.$colldate";

	open (STATO,">$logname") ||
		die "Cannot create output statfile \"$logname\"\n";
	foreach $group (keys %artstats) {
	    printf STATO ("$colldate %d %d %d %d %s\n",
			$artstats{$group}[$PRI_SIZE],
			$artstats{$group}[$PRI_COUNT],
			$artstats{$group}[$SEC_SIZE],
			$artstats{$group}[$SEC_COUNT],
			$group);
	}
	close STATO;
	rename $logname, "artsday.$colldate";
    }				# End of if defined $dumpflag
    $dumpflag = 1;
    %artstats = ();
}


foreach $INPUT (@ARGV) {
    $INPUT =~ /^artshour\.([0-9]{6})\.[0-9]{4}/ ||
	die "Invalid input file \"$INPUT\"\n";

    open(INPUT,$INPUT) || die "Cannot open input file \"$INPUT\"\n";

    while (<INPUT>) {
	($h_date, $h_time,
	 $pri_size, $pri_count, $sec_size, $sec_count, $group) = split;

	if ($h_date != $colldate) {
	    &dumpdata;
	    $colldate = $h_date;
	}

	$artstats{$group}[$PRI_SIZE]  += $pri_size;
	$artstats{$group}[$PRI_COUNT] += $pri_count;
	$artstats{$group}[$SEC_SIZE]  += $sec_size;
	$artstats{$group}[$SEC_COUNT] += $sec_count;

    } # End of while (<INPUT>)

} # End of foreach $INPUT (@ARGV)

&dumpdata;

exit;
