#!/usr/bin/perl

$debug = 0;

$FROM_SIZE = 0;		# Size of articles from feed.
$FROM_COUNT = 1;	# Count...

$colldate = 0;

@hour_size = ();
@hour_count = ();
$day_size = 0;
$day_count = 0;

$feedflag = 0;
%feedhost = ();
%fromhost = ();

format host_fmt_top =
Date: @<<<<<<<
      $reptdate
                Total      Bytes        Articles
 Total Bytes    Articles     / Second   / Second   Path Host
-------------   --------   ----------   --------   ------------------------
.
format hour_fmt_top =
                Articles   Bytes        Articles
Bytes / Hour      / Hour     / Second   / Second   Hour
-------------   --------   ----------   --------   -----
.
format detail_fmt =
@>>>>>>>>>>>>   @>>>>>>>   @>>>>>>>>>   @>>>>>>>   @<<<<<<<<<<<<<<<<<<<<<<<
$u_size,        $u_count,  $p_size,     $p_count,  $desc
.
format total_fmt =
-------------   --------   ----------   --------   ------------------------
@>>>>>>>>>>>>   @>>>>>>>   @>>>>>>>>>   @>>>>>>>   @<<<<<<<<<<<<<<<<<<<<<<<
$u_size,        $u_count,  $p_size,     $p_count,  $desc
.

# From the Perl FAQ
sub commify {
    local($_) = shift;
    1 while s/^(-?\d+)(\d{3})/$1,$2/;
    return $_;
}

sub print_day {
    print "\n\n\n\n" if defined $multi_day;
    ($reptdate = $colldate) =~ s/(\d\d)(\d\d)(\d\d)/$1-$2-$3/;
    select STDOUT;
    $^ = "host_fmt_top";
    $~ = "detail_fmt";
    $- = 0;
    $^L = "";
    foreach $host
	(sort { $fromhost{$b}[$FROM_SIZE] <=> $fromhost{$a}[$FROM_SIZE] }
	 keys %fromhost) {
	$u_size  = $fromhost{$host}[$FROM_SIZE];
	$u_count = $fromhost{$host}[$FROM_COUNT];
	$p_size  = &commify(sprintf("%.3f", $u_size  / 86400));
	$p_count = &commify(sprintf("%.3f", $u_count / 86400));
	$u_size  = &commify($u_size);
	$u_count = &commify($u_count);
	$desc = $host;
	write;
    }
    $~ = "total_fmt";
    $u_size  = &commify($day_size);
    $u_count = &commify($day_count);
    $p_size  = &commify(sprintf("%.3f", $day_size  / 86400));
    $p_count = &commify(sprintf("%.3f", $day_count / 86400));
    $desc = "Total";
    write;
    print "\n\n";
    $^ = "hour_fmt_top";
    $~ = "detail_fmt";
    $- = 0;
    for (0 .. $#hour_size) {
	next if ! defined $hour_size[$_];
	$p_size  = &commify(sprintf("%.3f", $hour_size[$_]  / 3600));
	$p_count = &commify(sprintf("%.3f", $hour_count[$_] / 3600));
	$u_size  = &commify($hour_size[$_]);
	$u_count = &commify($hour_count[$_]);
	$desc = sprintf("%02d:00", $_);
	write;
    }
    %fromhost = ();
    @hour_size  = ();
    @hour_count = ();
    $day_size  = 0;
    $day_count = 0;
    $multi_day = 1;
}

while (@ARGV) {
    $input = shift @ARGV;
    if ($input eq "-n") {
	$feedflag = 1;
	$inndhosts = "/home/news/hosts.nntp";
	open (INNDHOSTS, $inndhosts) ||
	    die "Cannot open inndhosts file \"$inndhosts\".\n";
	while (<INNDHOSTS>) {
	    next if /^#/;
	    next if /^\s*$/;
	    chop;
	    ($feedname) = split (':');
	    $feedhost{$feedname} = 1;
	}
	close (INNDHOSTS);
	$newsfeeds = $ENV{'NEWSFEEDS'};
	open (NEWSFEEDS, $newsfeeds) ||
	    die "Cannot open newsfeeds file \"$newsfeeds\".\n";
	$feedline = "";
	while (<NEWSFEEDS>) {
	    next if /^#/;
	    next if /^\s*$/;
	    chop;
	    s/^\s+(.*)$/$1/;
	    print STDERR "input = \"$_\"\n" if $debug;
	    $feedline .= $_;
	    if (/.*\\$/) {
		chop $feedline;
		$feedline =~ s/^(.*)\s+$/$1/;
		next;
	    }
	    print STDERR "Processing $feedline\n" if $debug;
	    ($feedexcl) = split (':', $feedline);
	    ($feedname, $exclusions) = split ('/', $feedexcl);
	    (@exclusion) = split (',', $exclusions);
	    print STDERR "Adding $feedname to feedhost table.\n" if $debug;
	    $feedhost{$feedname} = 1;
	    for (@exclusion) {
		print STDERR "Adding $_ to feedhost table.\n" if $debug;
		$feedhost{$_} = 1;
	    }
	    $feedline = "";
	} # End of while (<NEWSFEEDS>)
	close (NEWSFEEDS);
	next;
    } # End of if ($input eq "-n")
    if ($input =~ /^-f/) {
	$feedflag = 1;
	if ($input eq "-f") {
	    $feedhost{shift @ARGV} = 1; }
	else {
	    $input =~ s/^-f(.*)/$1/;
	    $feedhost{$input} = 1;
	}
	next;
    }
    if ($debug) {
	if ($feedflag == 1) {
	    $feedflag = 2;
	    print STDERR "Dump of feedhost table.\n";
	    for (keys %feedhost) {
		print STDERR "$_\n";
	    }
	}
    }
    open (INPUT, $input) || die "Cannot open input file \"$input\".\n";
    while (<INPUT>) {
	($i_date, $i_hour, $i_size, $i_count, $i_host) = split;

	if ($feedflag) {
	    if (! exists $feedhost{$i_host}) {
		$i_host = "Article(s) Posted";
	    }
	}
	if ($i_date != $colldate) {
	    if ($colldate != 0) {
		&print_day;
	    }
	    $colldate = $i_date;
	}

	$hour_size[$i_hour]  += $i_size;
	$hour_count[$i_hour] += $i_count;

	$day_size  += $i_size;
	$day_count += $i_count;

	$fromhost{$i_host}[$FROM_SIZE]  += $i_size;
	$fromhost{$i_host}[$FROM_COUNT] += $i_count;
    } # End of while (<>)
    close (INPUT);
} # End of while ($count = @ARGV)

if ($colldate != 0) {
    &print_day;
}

__END__

Example output:

Date: 96-03-06
                Total      Bytes        Articles
 Total Bytes    Articles     / Second   / Second   Path Host
-------------   --------   ----------   --------   ------------------------
  451,031,447     57,966    5,220.271      0.671   pa.dec.com
  166,784,987     43,279    1,930.382      0.501   nntpd.lkg.dec.com
   35,182,172     17,112      407.201      0.198   news.jrd.dec.com
      405,561         47        4.694      0.001   mrnews.mro.dec.com
        4,871          3        0.056      0.000   funlwb2.stl.dec.com
        4,111          3        0.048      0.000   vbehub.vbe.dec.com
        1,104          1        0.013      0.000   abbot.rhc.dec.com
          874          1        0.010      0.000   rtnews.rto.dec.com
-------------   --------   ----------   --------   ------------------------
  653,415,127    118,412    7,562.675      1.371   Total


                Articles   Bytes        Articles
Bytes / Hour      / Hour     / Second   / Second   Hour
-------------   --------   ----------   --------   -----
   37,411,541      7,361   10,392.095      2.045   00:00   
   32,135,673      7,370    8,926.576      2.047   01:00   
   32,223,233      4,969    8,950.898      1.380   02:00   
   34,897,297      4,802    9,693.694      1.334   03:00   
   37,776,794      4,426   10,493.554      1.229   04:00   
   22,401,834      4,051    6,222.732      1.125   05:00   
   13,782,362      5,729    3,828.434      1.591   06:00   
   19,089,980      5,534    5,302.772      1.537   07:00   
   20,313,442      5,353    5,642.623      1.487   08:00   
   24,186,706      4,236    6,718.529      1.177   09:00   
   16,546,430      3,112    4,596.231      0.864   10:00   
   11,380,196      1,631    3,161.166      0.453   11:00   
    8,689,726      2,031    2,413.813      0.564   12:00   
   14,612,137      3,327    4,058.927      0.924   13:00   
   12,629,226      3,548    3,508.118      0.986   14:00   
   26,627,223      4,258    7,396.451      1.183   15:00   
   39,047,943      5,235   10,846.651      1.454   16:00   
   31,720,289      5,177    8,811.191      1.438   17:00   
   36,663,860      5,098   10,184.406      1.416   18:00   
   52,302,801      8,428   14,528.556      2.341   19:00   
   31,623,162      4,368    8,784.212      1.213   20:00   
   24,358,708      3,477    6,766.308      0.966   21:00   
   32,910,146      5,230    9,141.707      1.453   22:00   
   40,084,418      9,661   11,134.561      2.684   23:00   
