#!/usr/bin/perl

$colldate = 0;

$day_size = 0;
$day_count = 0;

# From the Perl FAQ
sub commify {
    local($_) = shift;
    1 while s/^(-?\d+)(\d{3})/$1,$2/;
    return $_;
}

sub print_day {
    ($reptdate = $colldate) =~ s/(\d\d)(\d\d)(\d\d)/$1-$2-$3/;
    if ($reptdate =~ /01$/) {
	print STDOUT "\n",
	    "                          Total      Bytes        Articles\n",
	    "YY-MM-DD   Total Bytes    Articles     / Second   / Second\n",
	    "--------  -------------   --------   ----------   --------\n";
    }
    printf STDOUT ("%s  %13s   %8s   %10s   %8s\n", $reptdate,
		   &commify($day_size), &commify($day_count),
		   &commify(sprintf("%.3f", $day_size  / 86400)),
		   &commify(sprintf("%.3f", $day_count / 86400)));
    $day_size  = 0;
    $day_count = 0;
}

while (@ARGV) {
    $input = shift @ARGV;
    open (INPUT, $input) || die "Cannot open input file \"$input\".\n";
    while (<INPUT>) {
	($i_date, $i_hour, $i_size, $i_count) = split;

	if ($i_date != $colldate) {
	    if ($colldate != 0) {
		&print_day;
	    }
	    $colldate = $i_date;
	}

	$day_size  += $i_size;
	$day_count += $i_count;
    } # End of while (<>)
    close (INPUT);
} # End of while ($count = @ARGV)

if ($colldate != 0) {
    &print_day;
}

__END__

Example output:

96-10-10    996,727,627    171,425   11,536.199      1.984
